package net.java.dev.esjug.tutorialstruts2.controller;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import com.opensymphony.xwork2.ActionSupport;

public class TagsAction extends ActionSupport {
	/** String com valor fixo. */
	private String valorFixo = "Texto (caracteres HTML automaticamente convertidos: &\"<>)!";
	
	/** Lista de objetos para compor componentes de múltipla escolha. */
	private List<String> lista = new ArrayList<String>();
	
	/** Mapa para compor componentes chave x valor. */
	private Map<Integer, String> mapa = new TreeMap<Integer, String>();
	
	/** Valor do tipo Integer. */
	private Integer valorInt = 100;
	
	/** Valor do tipo Float. */
	private Float valorFloat = 1.25f;
	
	/** Valor do tipo Boolean. */
	private Boolean valorBoolean = true;
	
	/** Valor do tipo Date. */
	private Date valorDate = new Date();
	
	/** Valor do tipo Array de Character. */
	private Character[] valorArray = new Character[] {'W', 'e', 'b', 'W', 'o', 'r', 'k'};

	/** Construtor. */
	public TagsAction() {
		// Popula a lista.
		lista.add("Primeiro item");
		lista.add("Segundo item");
		lista.add("Terceiro item");
		lista.add("Quarto item");
		lista.add("Quinto item");
		
		// Popula o mapa.
		mapa.put(1, "Item com id 01");
		mapa.put(2, "Item com id 02");
		mapa.put(3, "Item com id 03");
		mapa.put(4, "Item com id 04");
  }

	/** Getter for lista. */
	public List<String> getLista() {
		return lista;
	}

	/** Getter for mapa. */
	public Map<Integer, String> getMapa() {
		return mapa;
	}

	/** Getter for valorFixo. */
	public String getValorFixo() {
		return valorFixo;
	}

	/** Getter for valorArray. */
	public Character[] getValorArray() {
		return valorArray;
	}

	/** Getter for valorBoolean. */
	public Boolean getValorBoolean() {
		return valorBoolean;
	}

	/** Getter for valorDate. */
	public Date getValorDate() {
		return valorDate;
	}

	/** Getter for valorFloat. */
	public Float getValorFloat() {
		return valorFloat;
	}

	/** Getter for valorInt. */
	public Integer getValorInt() {
		return valorInt;
	}

	/* Método execute() não precisa ser sobrescrito. Implementação de ActionSupport retorna SUCCESS. */
}
