package net.java.dev.esjug.tutorialstruts2.util;

import java.util.HashMap;
import java.util.Map;

/**
 * Esta classe faz parte do Tutorial WebWork, versão 2.2.2.
 * 
 * @author Vítor Souza (vitorsouza@gmail.com)
 */
public class ControleCadastro {
	/** Simula um banco de dados. */
	private static Map<Long, Funcionario> funcionarios = new HashMap<Long, Funcionario>();
	
	/** Próximo id. */
	private static long proximoId = 1;
	
	/** Obtém um funcionário dado o Id. */
	public static Funcionario obterFuncionario(Long id) {
		return funcionarios.get(id);
	}
	
	/** Grava um funcionário. */
	public static long gravarFuncionario(Funcionario vo) {
		Funcionario funcionario = new Funcionario(vo.getNome(), vo.getLogin(), vo.getSenha(), vo.getTipo());
		long id = proximoId++;
		funcionarios.put(id, funcionario);
		return id;
	}
}
