package net.java.dev.esjug.tutorialstruts2.util;

import java.util.HashMap;
import java.util.Map;

/**
 * Esta classe faz parte do Tutorial WebWork, versão 2.2.2.
 * 
 * @author Vítor Souza (vitorsouza@gmail.com)
 */
public class ControleLogin {
	/** Mapa de funcionários existentes (simulando um banco de dados). */
	private static Map<String, Funcionario> funcionarios = new HashMap<String, Funcionario>();
	
	static {
		// Monta o "banco de dados" de funcionários.
		Funcionario f = new Funcionario("James Gosling", "james", "james", Funcionario.TIPO_GERENTE);
		funcionarios.put(f.getLogin(), f);
		
		f = new Funcionario("Johnathan Schwartz", "johnathan", "johnathan", Funcionario.TIPO_DIRETOR);
		funcionarios.put(f.getLogin(), f);
		
		f = new Funcionario("John Doe", "john", "john", Funcionario.TIPO_DESENVOLVEDOR);
		funcionarios.put(f.getLogin(), f);
	}
	
	/** Obtém um funcionário por login. */
	public static Funcionario recuperarPorLogin(String login) {
		return funcionarios.get(login);
	}
}
