package net.java.dev.esjug.tutorialstruts2.controller;

import java.util.Calendar;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.Interceptor;

public class CumprimentoInterceptor implements Interceptor {
	@Override
	public void destroy() { }

	@Override
	public void init() { }

	@Override
	public String intercept(ActionInvocation invocation) throws Exception {
		// Decide qual cumprimento utilizar.
		Calendar calendar = Calendar.getInstance();
		int hora = calendar.get(Calendar.HOUR_OF_DAY);
		String cumprimento = (hora < 6) ? "Boa noite" : ((hora < 12) ? 
				"Bom dia" : ((hora < 18) ? "Boa tarde" : "Boa noite"));

		// Coloca o cumprimento na sessão.
		invocation.getInvocationContext().getSession().put("cumprimento", cumprimento);

		// Executa a ação.
		String result = invocation.invoke();
		
		// É possível executar código 
		// depois da ação aqui...

		// Retorna o resultado da ação.
		return result;
	}
}
