package net.java.dev.esjug.tutorialstruts2.controller;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.data.general.DefaultPieDataset;

import com.opensymphony.xwork2.ActionSupport;

public class GerarGraficoAction extends ActionSupport {
	private int usoSpring;
	private int usoStruts1;
	private int usoWebWork;
	private int usoStruts2;
	private String contentType = "image/jpeg";
	private InputStream inputStream;

	public int getUsoSpring() {
		return usoSpring;
	}

	public void setUsoSpring(int usoSpring) {
		this.usoSpring = usoSpring;
	}

	public int getUsoStruts1() {
		return usoStruts1;
	}

	public void setUsoStruts1(int usoStruts1) {
		this.usoStruts1 = usoStruts1;
	}

	public int getUsoWebWork() {
		return usoWebWork;
	}

	public void setUsoWebWork(int usoWebWork) {
		this.usoWebWork = usoWebWork;
	}

	public int getUsoStruts2() {
		return usoStruts2;
	}

	public void setUsoStruts2(int usoStruts2) {
		this.usoStruts2 = usoStruts2;
	}

	public String getContentType() {
		return contentType;
	}

	public InputStream getInputStream() {
		return inputStream;
	}

	public String execute() throws Exception {
		// Monta o dataset que populará o gráfico.
		DefaultPieDataset dataset = new DefaultPieDataset();
		dataset.setValue("Spring MVC", usoSpring);
		dataset.setValue("Struts 1", usoStruts1);
		dataset.setValue("WebWork", usoWebWork);
		dataset.setValue("Struts 2", usoStruts2);
		
		// Gera o gráfico.
		JFreeChart grafico = ChartFactory.createPieChart3D("Uso de Frameworks Web", dataset, true, false, false);
		
		// Coloca o gráfico no input stream que será lido pelo struts.
		ByteArrayOutputStream outStream = new ByteArrayOutputStream();
		ChartUtilities.writeChartAsJPEG(outStream, grafico, 600, 300);
		inputStream = new ByteArrayInputStream(outStream.toByteArray());

		return SUCCESS;
	}
}
