package net.java.dev.esjug.tutorialstruts2.controller;

import net.java.dev.esjug.tutorialstruts2.util.ControleLogin;
import net.java.dev.esjug.tutorialstruts2.util.Funcionario;

import com.opensymphony.xwork2.ActionSupport;

public class LoginAction extends ActionSupport {
	private String login;

	private String senha;
	
	private Funcionario funcionario;
	
	private String mensagemErro;

	/**
	 * Accessor method for login attribute.
	 *
	 * @return the login
	 */
	public String getLogin() {
		return login;
	}

	/**
	 * Mutator method for login attribute.
	 *
	 * @param login the login to set
	 */
	public void setLogin(String login) {
		this.login = login;
	}

	/**
	 * Accessor method for senha attribute.
	 *
	 * @return the senha
	 */
	public String getSenha() {
		return senha;
	}

	/**
	 * Mutator method for senha attribute.
	 *
	 * @param senha the senha to set
	 */
	public void setSenha(String senha) {
		this.senha = senha;
	}

	/**
	 * Accessor method for funcionario attribute.
	 *
	 * @return the funcionario
	 */
	public Funcionario getFuncionario() {
		return funcionario;
	}

	/**
	 * Mutator method for funcionario attribute.
	 *
	 * @param funcionario the funcionario to set
	 */
	public void setFuncionario(Funcionario funcionario) {
		this.funcionario = funcionario;
	}

	/**
	 * Accessor method for mensagemErro attribute.
	 *
	 * @return the mensagemErro
	 */
	public String getMensagemErro() {
		return mensagemErro;
	}

	/**
	 * Mutator method for mensagemErro attribute.
	 *
	 * @param mensagemErro the mensagemErro to set
	 */
	public void setMensagemErro(String mensagemErro) {
		this.mensagemErro = mensagemErro;
	}

	/* (non-Javadoc)
	 * @see com.opensymphony.xwork2.ActionSupport#execute()
	 */
	@Override
	public String execute() throws Exception {
		funcionario = ControleLogin.recuperarPorLogin(login);
		
		if (funcionario == null) {
			mensagemErro = "Login inexistente!";
			return INPUT;
		}
		
		if (! funcionario.getSenha().equals(senha)) {
			mensagemErro = "Senha incorreta!";
			return INPUT;
		}
		
		switch (funcionario.getTipo()) {
		case Funcionario.TIPO_DESENVOLVEDOR: return "desenvolvedor";
		case Funcionario.TIPO_GERENTE: return "gerente";
		case Funcionario.TIPO_DIRETOR: return "diretor";
		}
		
		return INPUT;
	}
}
